'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultOptions = {
    ast: false
};

exports.default = function (userOptions) {
    return function (input) {
        return function babel(log) {
            var babelTransform = require('babel-core').transform;

            return _promise2.default.all(input.map(function (file) {
                return new _promise2.default(function (resolve) {
                    var options = (0, _extends3.default)({}, defaultOptions, {
                        inputSourceMap: file.map
                    }, userOptions, {
                        filename: file.path
                    });
                    var result = babelTransform(file.data, options);

                    log(file.path);

                    resolve({
                        path: file.path,
                        data: result.code,
                        map: result.map
                    });
                });
            }));
        };
    };
};

module.exports = exports['default'];